OGRE: Ogre::Overlay Class Reference - OGRE Documentation

Public Types | Public Member Functions | Protected Member Functions | Protected Attributes

# Ogre::Overlay Class Reference
[Overlays]

Represents a layer which is rendered on top of the 'normal' scene contents. More...

`#include <OgreOverlay.h>`

Inheritance diagram for Ogre::Overlay:
[legend]

List of all members.

## Public Types
typedef list< OverlayContainer * > ::type | OverlayContainerList
typedef VectorIterator < OverlayContainerList > | Overlay2DElementsIterator
| Returns an iterator over all 2D elements in this manager.
## Public Member Functions
| Overlay (const String &name)
| Constructor: do not call direct, use OverlayManager::create.
virtual | ~Overlay ()
OverlayContainer * | getChild (const String &name)
const String & | getName (void) const
| Gets the name of this overlay.
void | setZOrder (ushort zorder)
| Alters the ZOrder of this overlay.
ushort | getZOrder (void) const
| Gets the ZOrder of this overlay.
bool | isVisible (void) const
| Gets whether the overlay is displayed or not.
bool | isInitialised (void) const
| Gets whether the overlay is initialised or not.
void | show (void)
| Shows the overlay if it was hidden.
void | hide (void)
| Hides the overlay if it was visible.
void | add2D (OverlayContainer *cont)
| Adds a 2D 'container' to the overlay.
void | remove2D (OverlayContainer *cont)
| Removes a 2D container from the overlay.
void | add3D (SceneNode *node)
| Adds a node capable of holding 3D objects to the overlay.
void | remove3D (SceneNode *node)
| Removes a 3D element from the overlay.
void | clear ()
| Clears the overlay of all attached items.
void | setScroll (Real x, Real y)
| Sets the scrolling factor of this overlay.
Real | getScrollX (void) const
| Gets the current X scroll value.
Real | getScrollY (void) const
| Gets the current Y scroll value.
void | scroll (Real xoff, Real yoff)
| Scrolls the overlay by the offsets provided.
void | setRotate (const Radian &angle)
| Sets the rotation applied to this overlay.
const Radian & | getRotate (void) const
| Gets the rotation applied to this overlay, in degrees.
void | rotate (const Radian &angle)
| Adds the passed in angle to the rotation applied to this overlay.
void | setScale (Real x, Real y)
| Sets the scaling factor of this overlay.
Real | getScaleX (void) const
| Gets the current X scale value.
Real | getScaleY (void) const
| Gets the current Y scale value.
void | _getWorldTransforms (Matrix4 *xform) const
| Used to transform the overlay when scrolling, scaling etc.
void | _findVisibleObjects (Camera *cam, RenderQueue *queue)
| Internal method to put the overlay contents onto the render queue.
virtual OverlayElement * | findElementAt (Real x, Real y)
| This returns a OverlayElement at position x,y.
Overlay2DElementsIterator | get2DElementsIterator ()
const String & | getOrigin (void) const
| Get the origin of this overlay, e.g.
void | _notifyOrigin (const String &origin)
| Notify this overlay of it's origin.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
## Protected Member Functions
void | updateTransform (void) const
| Internal lazy update method.
void | initialise (void)
| Internal method for initialising an overlay.
void | assignZOrders (void)
| Internal method for updating container elements' Z-ordering.
## Protected Attributes
String | mName
SceneNode * | mRootNode
| Internal root node, used as parent for 3D objects.
OverlayContainerList | m2DElements
Radian | mRotate
Real | mScrollX
Real | mScrollY
Real | mScaleX
Real | mScaleY
Matrix4 | mTransform
bool | mTransformOutOfDate
bool | mTransformUpdated
ulong | mZOrder
bool | mVisible
bool | mInitialised
String | mOrigin

## Detailed Description

Represents a layer which is rendered on top of the 'normal' scene contents.

Remarks:
  An overlay is a container for visual components (2D and 3D) which will be rendered after the main scene in order to composite heads-up-displays, menus or other layers on top of the contents of the scene.

  An overlay always takes up the entire size of the viewport, although the components attached to it do not have to. An overlay has no visual element in itself, it it merely a container for visual elements.

  Overlays are created by calling OverlayManager::create, or by defining them in special text scripts (.overlay files). As many overlays as you like can be defined; after creation an overlay is hidden i.e. not visible until you specifically enable it by calling 'show'. This allows you to have multiple overlays predefined (menus etc) which you make visible only when you want. It is possible to have multiple overlays enabled at once; in this case the relative 'zorder' parameter of the overlays determine which one is displayed on top.

  By default overlays are rendered into all viewports. This is fine when you only have fullscreen viewports, but if you have picture-in-picture views, you probably don't want the overlay displayed in the smaller viewports. You turn this off for a specific viewport by calling the Viewport::setDisplayOverlays method.

Definition at line 70 of file OgreOverlay.h.

## Member Typedef Documentation

typedef VectorIterator<OverlayContainerList> Ogre::Overlay::Overlay2DElementsIterator

Returns an iterator over all 2D elements in this manager.

Remarks:
  VectorIterator is actually a too generic name, since it also works for lists.

Definition at line 256 of file OgreOverlay.h.

typedef list<OverlayContainer*>::type Ogre::Overlay::OverlayContainerList

Definition at line 74 of file OgreOverlay.h.

## Constructor & Destructor Documentation

Ogre::Overlay::Overlay | ( | const String & | name | ) |

Constructor: do not call direct, use OverlayManager::create.

virtual Ogre::Overlay::~Overlay | ( |  | ) | `[virtual]`

## Member Function Documentation

void Ogre::Overlay::_findVisibleObjects | ( | Camera * | cam,
|  | RenderQueue * | queue |
| ) |  |  |

Internal method to put the overlay contents onto the render queue.

void Ogre::Overlay::_getWorldTransforms | ( | Matrix4 * | xform | ) | const

Used to transform the overlay when scrolling, scaling etc.

void Ogre::Overlay::_notifyOrigin | ( | const String & | origin | ) |

Notify this overlay of it's origin.

Definition at line 269 of file OgreOverlay.h.

void Ogre::Overlay::add2D | ( | OverlayContainer * | cont | ) |

Adds a 2D 'container' to the overlay.

Remarks:
  Containers are created and managed using the OverlayManager. A container could be as simple as a square panel, or something more complex like a grid or tree view. Containers group collections of other elements, giving them a relative coordinate space and a common z-order. If you want to attach a GUI widget to an overlay, you have to do it via a container.

Parameters:

  | cont | Pointer to a container to add, created using OverlayManager.

void Ogre::Overlay::add3D | ( | SceneNode * | node | ) |

Adds a node capable of holding 3D objects to the overlay.

Remarks:
  Although overlays are traditionally associated with 2D elements, there are reasons why you might want to attach 3D elements to the overlay too. For example, if you wanted to have a 3D cockpit, which was overlaid with a HUD, then you would create 2 overlays, one with a 3D object attached for the cockpit, and one with the HUD elements attached (the zorder of the HUD overlay would be higher than the cockpit to ensure it was always on top).

  A SceneNode can have any number of 3D objects attached to it. SceneNodes are usually created using SceneManager::createSceneNode, but in this case you should create a standard SceneNode instance manually; this is because these scene nodes are not managed by the SceneManager and some custom SceneManager plugins will rely on specialist behaviour the overlay does not support. By attaching a SceneNode to an overlay, you indicate that:
  1. You want the contents of this node to only appear when the overlay is active
  2. You want the node to inherit a coordinate space relative to the camera, rather than relative to the root scene node
  3. You want these objects to be rendered after the contents of the main scene to ensure they are rendered on top
  One major consideration when using 3D objects in overlays is the behaviour of the depth buffer. Overlays should use materials with depth checking off, to ensure that their contents are always displayed on top of the main scene (to do otherwise would result in objects 'poking through' the overlay). The problem with using 3D objects is that if they are concave, or self-overlap, then you can get artefacts because of the lack of depth buffer checking. So you should ensure that any 3D objects you us in the overlay are convex, and don't overlap each other. If they must overlap, split them up and put them in 2 overlays. Alternatively, use a 2D element underneath them which will clear the depth buffer values underneath ready for the 3D element to be rendered correctly.

void Ogre::Overlay::assignZOrders | ( | void |  | ) | `[protected]`

Internal method for updating container elements' Z-ordering.

void Ogre::Overlay::clear | ( |  | ) |

Clears the overlay of all attached items.

virtual OverlayElement* Ogre::Overlay::findElementAt | ( | Real | x,
|  | Real | y |
| ) |  |  | `[virtual]`

This returns a OverlayElement at position x,y.

Overlay2DElementsIterator Ogre::Overlay::get2DElementsIterator | ( |  | ) |

Definition at line 257 of file OgreOverlay.h.

OverlayContainer* Ogre::Overlay::getChild | ( | const String & | name | ) |

const String& Ogre::Overlay::getName | ( | void |  | ) | const

Gets the name of this overlay.

const String& Ogre::Overlay::getOrigin | ( | void |  | ) | const

Get the origin of this overlay, e.g.

a script file name.

Remarks:
  This property will only contain something if the creator of this overlay chose to populate it. Script loaders are advised to populate it.

Definition at line 267 of file OgreOverlay.h.

const Radian& Ogre::Overlay::getRotate | ( | void |  | ) | const

Gets the rotation applied to this overlay, in degrees.

Definition at line 223 of file OgreOverlay.h.

Real Ogre::Overlay::getScaleX | ( | void |  | ) | const

Gets the current X scale value.

Real Ogre::Overlay::getScaleY | ( | void |  | ) | const

Gets the current Y scale value.

Real Ogre::Overlay::getScrollX | ( | void |  | ) | const

Gets the current X scroll value.

Real Ogre::Overlay::getScrollY | ( | void |  | ) | const

Gets the current Y scroll value.

ushort Ogre::Overlay::getZOrder | ( | void |  | ) | const

Gets the ZOrder of this overlay.

void Ogre::Overlay::hide | ( | void |  | ) |

Hides the overlay if it was visible.

void Ogre::Overlay::initialise | ( | void |  | ) | `[protected]`

Internal method for initialising an overlay.

bool Ogre::Overlay::isInitialised | ( | void |  | ) | const

Gets whether the overlay is initialised or not.

Definition at line 127 of file OgreOverlay.h.

bool Ogre::Overlay::isVisible | ( | void |  | ) | const

Gets whether the overlay is displayed or not.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 107 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 118 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 72 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 78 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 85 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 90 of file OgreMemoryAllocatedObject.h.

void Ogre::Overlay::remove2D | ( | OverlayContainer * | cont | ) |

Removes a 2D container from the overlay.

Remarks:
  NOT FAST. Consider OverlayElement::hide.

void Ogre::Overlay::remove3D | ( | SceneNode * | node | ) |

Removes a 3D element from the overlay.

void Ogre::Overlay::rotate | ( | const Radian & | angle | ) |

Adds the passed in angle to the rotation applied to this overlay.

void Ogre::Overlay::scroll | ( | Real | xoff,
|  | Real | yoff |
| ) |  |  |

Scrolls the overlay by the offsets provided.

Remarks:
  This method moves the overlay by the amounts provided. As with other methods on this object, a full screen width / height is represented by the value 1.0.

void Ogre::Overlay::setRotate | ( | const Radian & | angle | ) |

Sets the rotation applied to this overlay.

void Ogre::Overlay::setScale | ( | Real | x,
|  | Real | y |
| ) |  |  |

Sets the scaling factor of this overlay.

Remarks:
  You can use this to set an scale factor to be used to zoom an overlay.

Parameters:

  | x | Horizontal scale value, where 1.0 = normal, 0.5 = half size etc
  | y | Vertical scale value, where 1.0 = normal, 0.5 = half size etc

void Ogre::Overlay::setScroll | ( | Real | x,
|  | Real | y |
| ) |  |  |

Sets the scrolling factor of this overlay.

Remarks:
  You can use this to set an offset to be used to scroll an overlay around the screen.

Parameters:

  | x | Horizontal scroll value, where 0 = normal, -0.5 = scroll so that only the right half the screen is visible etc
  | y | Vertical scroll value, where 0 = normal, 0.5 = scroll down by half a screen etc.

void Ogre::Overlay::setZOrder | ( | ushort | zorder | ) |

Alters the ZOrder of this overlay.

Remarks:
  Values between 0 and 650 are valid here.

void Ogre::Overlay::show | ( | void |  | ) |

Shows the overlay if it was hidden.

void Ogre::Overlay::updateTransform | ( | void |  | ) | const`[protected]`

Internal lazy update method.

## Member Data Documentation

OverlayContainerList Ogre::Overlay::m2DElements`[protected]`

Definition at line 82 of file OgreOverlay.h.

bool Ogre::Overlay::mInitialised`[protected]`

Definition at line 96 of file OgreOverlay.h.

String Ogre::Overlay::mName`[protected]`

Definition at line 76 of file OgreOverlay.h.

String Ogre::Overlay::mOrigin`[protected]`

Definition at line 97 of file OgreOverlay.h.

SceneNode* Ogre::Overlay::mRootNode`[protected]`

Internal root node, used as parent for 3D objects.

Definition at line 78 of file OgreOverlay.h.

Radian Ogre::Overlay::mRotate`[protected]`

Definition at line 85 of file OgreOverlay.h.

Real Ogre::Overlay::mScaleX`[protected]`

Definition at line 89 of file OgreOverlay.h.

Real Ogre::Overlay::mScaleY`[protected]`

Definition at line 89 of file OgreOverlay.h.

Real Ogre::Overlay::mScrollX`[protected]`

Definition at line 87 of file OgreOverlay.h.

Real Ogre::Overlay::mScrollY`[protected]`

Definition at line 87 of file OgreOverlay.h.

Matrix4 Ogre::Overlay::mTransform`[mutable, protected]`

Definition at line 91 of file OgreOverlay.h.

bool Ogre::Overlay::mTransformOutOfDate`[mutable, protected]`

Definition at line 92 of file OgreOverlay.h.

bool Ogre::Overlay::mTransformUpdated`[protected]`

Definition at line 93 of file OgreOverlay.h.

bool Ogre::Overlay::mVisible`[protected]`

Definition at line 95 of file OgreOverlay.h.

ulong Ogre::Overlay::mZOrder`[protected]`

Definition at line 94 of file OgreOverlay.h.

The documentation for this class was generated from the following file:

- OgreOverlay.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Wed Nov 3 2010 19:24:57